﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO.Ports;
using System.Windows.Forms;

namespace Client
{
    class Com
    {
        private string buffer;  //буфер 
        private string value;   //форматированные данные для отображения 
        private TextBox textBox;//элемент для вывода на экран
        private SerialPort port = new SerialPort("COM1", 19200, Parity.None, 8, StopBits.One);
        //ну и естественно сам порт
        public Com(TextBox textBox)
        {
            this.textBox = textBox;
        }
        private void received(object sender, SerialDataReceivedEventArgs e)
        {
            buffer += port.ReadExisting();
            if (buffer.Contains('\n'))
            {
                value = buffer.Split('\n')[0];
                buffer = buffer.Remove(0, value.Length + 1);
                if (textBox.InvokeRequired)
                    textBox.Invoke((MethodInvoker) delegate { textBox.Text = value; });
                else
                    textBox.Text = value;
            }
        }
        public void Strart()
        {
            port.DataReceived += new SerialDataReceivedEventHandler(received);
            port.Open();
        }
        public void Stop()
        {
            port.Close();
        }
    }
}